//RawIO module for GMod by Hexxeh
#include <string>
#include <sstream>
#include <fstream>
#include <stdio.h>
#include <windows.h>
#include "headers/GMLuaModule.h"

using namespace std;

GMOD_MODULE(Init, Shutdown);

LUA_FUNCTION(writefile) {
	const char* filename = g_Lua->GetString(1);
	const char* text = g_Lua->GetString(2);
	ofstream file (filename);
	if(file.is_open()) {
		file << text;
		file.close();
		g_Lua->Push((bool)1);
	} else {
		g_Lua->Push((bool)0);
	}
	return 1;
}

LUA_FUNCTION(readfile) {
	const char* filename = g_Lua->GetString(1);
	ifstream file (filename);
	if(file.is_open()) {
		string line;
		ostringstream text;
		while (!file.eof()) {
			getline(file,line);
			text << line << endl;
		}
		g_Lua->Push(text.str().c_str());
		file.close();
	} else {
		g_Lua->Push((bool)0);
	}
	return 1;
}

LUA_FUNCTION(deletefile) {
	const char* path = g_Lua->GetString(1);
	int res = remove(path);
	if(res != 0) {
		g_Lua->Push((bool)1);
	} else {
		g_Lua->Push((bool)0);
	}
	return 1;
}

LUA_FUNCTION(mkdir) {
	const char* path = g_Lua->GetString(1);
	LPSECURITY_ATTRIBUTES attr;
	attr = NULL;
	int res = CreateDirectory(path,attr);
	if(res != 0) {
		g_Lua->Push((bool)1);
	} else {
		g_Lua->Push((bool)0);
	}
	return 1;
}

int Init(void) {
	Msg("gm_rawio has loaded!\n");

	g_Lua->NewGlobalTable("rawio");
	ILuaObject* table = g_Lua->GetGlobal("rawio");
		table->SetMember( "writefile", writefile );
		table->SetMember( "readfile", readfile );
		table->SetMember( "deletefile", deletefile );
		table->SetMember( "mkdir", mkdir );
	SAFE_UNREF( table );

	return 0;
}

int Shutdown(void) {
	return 0;
}